org.apache.lucene.analysis.util

## Class CharTokenizer

- java.lang.Object
- - org.apache.lucene.util.AttributeSource
  - - org.apache.lucene.analysis.TokenStream
    - - org.apache.lucene.analysis.Tokenizer
      - - org.apache.lucene.analysis.util.CharTokenizer

- All Implemented Interfaces:
    Closeable, AutoCloseable
  Direct Known Subclasses:
    LetterTokenizer, UnicodeWhitespaceTokenizer, WhitespaceTokenizer

      public abstract class CharTokenizer
      extends Tokenizer

  An abstract base class for simple, character-oriented tokenizers.

  The base class also provides factories to create instances of `CharTokenizer` using Java 8 lambdas or method references. It is possible to create an instance which behaves exactly like `LetterTokenizer`:

       Tokenizer tok = CharTokenizer.fromTokenCharPredicate(Character::isLetter);

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.util.AttributeSource

      `AttributeSource.State`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `DEFAULT_MAX_WORD_LEN`

    - ### Fields inherited from class org.apache.lucene.analysis.Tokenizer

      `input`

    - ### Fields inherited from class org.apache.lucene.analysis.TokenStream

      `DEFAULT_TOKEN_ATTRIBUTE_FACTORY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `CharTokenizer()` Creates a new `CharTokenizer` instance
    `CharTokenizer(AttributeFactory factory)` Creates a new `CharTokenizer` instance
    `CharTokenizer(AttributeFactory factory, int maxTokenLen)` Creates a new `CharTokenizer` instance

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `end()`
    `static CharTokenizer` | `fromSeparatorCharPredicate(AttributeFactory factory, IntPredicate separatorCharPredicate)` Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate, supplied as method reference or lambda expression.
    `static CharTokenizer` | `fromSeparatorCharPredicate(AttributeFactory factory, IntPredicate separatorCharPredicate, IntUnaryOperator normalizer)` Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate.
    `static CharTokenizer` | `fromSeparatorCharPredicate(IntPredicate separatorCharPredicate)` Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression.
    `static CharTokenizer` | `fromSeparatorCharPredicate(IntPredicate separatorCharPredicate, IntUnaryOperator normalizer)` Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression.
    `static CharTokenizer` | `fromTokenCharPredicate(AttributeFactory factory, IntPredicate tokenCharPredicate)` Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate, supplied as method reference or lambda expression.
    `static CharTokenizer` | `fromTokenCharPredicate(AttributeFactory factory, IntPredicate tokenCharPredicate, IntUnaryOperator normalizer)` Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate, supplied as method reference or lambda expression.
    `static CharTokenizer` | `fromTokenCharPredicate(IntPredicate tokenCharPredicate)` Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression.
    `static CharTokenizer` | `fromTokenCharPredicate(IntPredicate tokenCharPredicate, IntUnaryOperator normalizer)` Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression.
    `boolean` | `incrementToken()`
    `protected abstract boolean` | `isTokenChar(int c)` Returns true iff a codepoint should be included in a token.
    `protected int` | `normalize(int c)` Called on each token character to normalize it before it is added to the token.
    `void` | `reset()`

    - ### Methods inherited from class org.apache.lucene.analysis.Tokenizer

      `close, correctOffset, setReader`

    - ### Methods inherited from class org.apache.lucene.util.AttributeSource

      `addAttribute, addAttributeImpl, captureState, clearAttributes, cloneAttributes, copyTo, endAttributes, equals, getAttribute, getAttributeClassesIterator, getAttributeFactory, getAttributeImplsIterator, hasAttribute, hasAttributes, hashCode, reflectAsString, reflectWith, removeAllAttributes, restoreState, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_MAX_WORD_LEN

          public static final int DEFAULT_MAX_WORD_LEN

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### CharTokenizer

          public CharTokenizer()

      Creates a new `CharTokenizer` instance

    - #### CharTokenizer

          public CharTokenizer(AttributeFactory factory)

      Creates a new `CharTokenizer` instance
      Parameters:
        `factory` - the attribute factory to use for this `Tokenizer`

    - #### CharTokenizer

          public CharTokenizer(AttributeFactory factory,
                               int maxTokenLen)

      Creates a new `CharTokenizer` instance
      Parameters:
        `factory` - the attribute factory to use for this `Tokenizer`
        `maxTokenLen` - maximum token length the tokenizer will emit. Must be greater than 0 and less than MAX_TOKEN_LENGTH_LIMIT (1024*1024)
      Throws:
        `IllegalArgumentException` - if maxTokenLen is invalid.

  - ### Method Detail

    - #### fromTokenCharPredicate

          public static CharTokenizer fromTokenCharPredicate(IntPredicate tokenCharPredicate)

      Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token characters.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `LetterTokenizer` is:

           Tokenizer tok = CharTokenizer.fromTokenCharPredicate(Character::isLetter);

    - #### fromTokenCharPredicate

          public static CharTokenizer fromTokenCharPredicate(AttributeFactory factory,
                                                             IntPredicate tokenCharPredicate)

      Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token characters.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `LetterTokenizer` is:

           Tokenizer tok = CharTokenizer.fromTokenCharPredicate(factory, Character::isLetter);

    - #### fromTokenCharPredicate

          public static CharTokenizer fromTokenCharPredicate(IntPredicate tokenCharPredicate,
                                                             IntUnaryOperator normalizer)

      Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token characters. This factory also takes a function to normalize chars, e.g., lowercasing them, supplied as method reference or lambda expression.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `LowerCaseTokenizer` is:

           Tokenizer tok = CharTokenizer.fromTokenCharPredicate(Character::isLetter, Character::toLowerCase);

    - #### fromTokenCharPredicate

          public static CharTokenizer fromTokenCharPredicate(AttributeFactory factory,
                                                             IntPredicate tokenCharPredicate,
                                                             IntUnaryOperator normalizer)

      Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token characters. This factory also takes a function to normalize chars, e.g., lowercasing them, supplied as method reference or lambda expression.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `LowerCaseTokenizer` is:

           Tokenizer tok = CharTokenizer.fromTokenCharPredicate(factory, Character::isLetter, Character::toLowerCase);

    - #### fromSeparatorCharPredicate

          public static CharTokenizer fromSeparatorCharPredicate(IntPredicate separatorCharPredicate)

      Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token separator characters. This method is provided for convenience to easily use predicates that are negated (they match the separator characters, not the token characters).

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `WhitespaceTokenizer` is:

           Tokenizer tok = CharTokenizer.fromSeparatorCharPredicate(Character::isWhitespace);

    - #### fromSeparatorCharPredicate

          public static CharTokenizer fromSeparatorCharPredicate(AttributeFactory factory,
                                                                 IntPredicate separatorCharPredicate)

      Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token separator characters.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `WhitespaceTokenizer` is:

           Tokenizer tok = CharTokenizer.fromSeparatorCharPredicate(factory, Character::isWhitespace);

    - #### fromSeparatorCharPredicate

          public static CharTokenizer fromSeparatorCharPredicate(IntPredicate separatorCharPredicate,
                                                                 IntUnaryOperator normalizer)

      Creates a new instance of CharTokenizer using a custom predicate, supplied as method reference or lambda expression. The predicate should return `true` for all valid token separator characters. This factory also takes a function to normalize chars, e.g., lowercasing them, supplied as method reference or lambda expression.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as the combination `WhitespaceTokenizer` and `LowerCaseFilter` is:

           Tokenizer tok = CharTokenizer.fromSeparatorCharPredicate(Character::isWhitespace, Character::toLowerCase);

    - #### fromSeparatorCharPredicate

          public static CharTokenizer fromSeparatorCharPredicate(AttributeFactory factory,
                                                                 IntPredicate separatorCharPredicate,
                                                                 IntUnaryOperator normalizer)

      Creates a new instance of CharTokenizer with the supplied attribute factory using a custom predicate. The predicate should return `true` for all valid token separator characters. This factory also takes a function to normalize chars, e.g., lowercasing them, supplied as method reference or lambda expression.

      This factory is intended to be used with lambdas or method references. E.g., an elegant way to create an instance which behaves exactly as `WhitespaceTokenizer` and `LowerCaseFilter` is:

           Tokenizer tok = CharTokenizer.fromSeparatorCharPredicate(factory, Character::isWhitespace, Character::toLowerCase);

    - #### isTokenChar

          protected abstract boolean isTokenChar(int c)

      Returns true iff a codepoint should be included in a token. This tokenizer generates as tokens adjacent sequences of codepoints which satisfy this predicate. Codepoints for which this is false are used to define token boundaries and are not included in tokens.

    - #### normalize

          protected int normalize(int c)

      Called on each token character to normalize it before it is added to the token. The default implementation does nothing. Subclasses may use this to, e.g., lowercase tokens.

    - #### incrementToken

          public final boolean incrementToken()
                                       throws IOException

      Specified by:
        `incrementToken` in class `TokenStream`
      Throws:
        `IOException`

    - #### end

          public final void end()
                         throws IOException

      Overrides:
        `end` in class `TokenStream`
      Throws:
        `IOException`

    - #### reset

          public void reset()
                     throws IOException

      Overrides:
        `reset` in class `Tokenizer`
      Throws:
        `IOException`

Copyright © 2000-2018 Apache Software Foundation. All Rights Reserved.